(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











BeginPackage["RMCPackages`ListScheduling`","DiscreteMath`Combinatorica`",\
"Graphics`Arrow`","Utilities`FilterOptions`"]







AllScheduleTimes::usage=
    "AllScheduleTimes[tasktimes, edges, processors] applies the \
list-processing algorithm to every possible priority list, and calculates the \
total times needed for each of the n! schedules (where n is the total number \
of tasks). It will return a table showing how frequently each schedule time \
occurs. Note that this command works via brute force and will take a very \
long time to execute if n is greater than 7 or so. The syntax for the three \
arguments is as follows: tasktimes is a list of times for the tasks. For \
instance, {3,5,2} would be used if there were three tasks, with task one \
taking 3 minutes, task two taking 5 minutes, and task three taking 2 minutes. \
edges is the list of directed edges in the order-requirement digraph. Each \
edge is itself expressed as a list of length two, so edges is a nested list. \
For example {{1,2},{2,3}} would be used if there is an arrow from task 1 to \
task 2, and another arrow from task 2 to task 3. Lastly, processors is the \
number of processors to be used (a number such as 1, 2 or 3). The option \
setting Reminders->False will suppress the printout of the input \
information.";

LPA::usage=
    "LPA[tasktimes, prioritylist, edges, processors] returns the schedule \
produced by applying the list processing algorithm. The output is a list of \
length two. The first item is a nested list of task numbers, one for each \
processor, showing the order in which the tasks will be performed. The second \
is a nested list of task completion times, one for each processor. The syntax \
for the four arguments is as follows: tasktimes is a list of times for the \
tasks. For instance, {3,5,2} would be used if there were three tasks, with \
task one taking 3 minutes, task two taking 5 minutes, and task three taking 2 \
minutes. prioritylist is list of the task numbers in order of priority. For \
example {3,1,2} would be used if task 3 has highest priority, followed by \
task 1, and then task 2. edges is the list of directed edges in the \
order-requirement digraph. Each edge is itself expressed as a list of length \
two, so edges is a nested list. For example {{1,2},{2,3}} would be used if \
there is an arrow from task 1 to task 2, and another arrow from task 2 to \
task 3. Lastly, processors is the number of processors to be used (a number \
such as 1, 2 or 3).";


RenderSchedule::usage=
    "RenderSchedule[{tasks, schedtimes}, xreference] takes a schedule object \
in the form returned by LPA as its first argument, and a positive number as \
its second. In the first argument, tasks is a nested list of the ordered task \
numbers assigned to each processor (with a non-numeric value such as 'idle' \
used to denote idle time. schedtimes is a nested list of the start and finish \
times for tasks on each processor. For the second argument, xreference is a \
number used to set the scale on the horizontal axis, and should be set to a \
value near the maximum completion time. The scale will be such that this \
number appears 400 printer's points from the left (it is a useful feature \
when two schedules need to be shown with the same scaling on the time axis). \
RenderSchedule is called by ShowSchedule, and is only needed as a stand-alone \
command to manually produce a scheduling graphic.";

ScheduleTime::usage=
    "ScheduleTime[tasktimes, prioritylist, edges, processors] returns the \
total time taken by the schedule produced by applying the list processing \
algorithm. The syntax for the four arguments is as follows: tasktimes is a \
list of times for the tasks. For instance, {3,5,2} would be used if there \
were three tasks, with task one taking 3 minutes, task two taking 5 minutes, \
and task three taking 2 minutes. prioritylist is list of the task numbers in \
order of priority. For example {3,1,2} would be used if task 3 has highest \
priority, followed by task 1, and then task 2. edges is the list of directed \
edges in the order-requirement digraph. Each edge is itself expressed as a \
list of length two, so edges is a nested list. For example {{1,2},{2,3}} \
would be used if there is an arrow from task 1 to task 2, and another arrow \
from task 2 to task 3. Lastly, processors is the number of processors to be \
used (a number such as 1, 2 or 3).";

ShowSchedule::"usage"=
    "ShowSchedule[tasktimes, prioritylist, edges, processors] returns the \
schedule produced by applying the list processing algorithm. The syntax for \
the four arguments is as follows: tasktimes is a list of times for the tasks. \
For instance, {3,5,2} would be used if there were three tasks, with task one \
taking 3 minutes, task two taking 5 minutes, and task three taking 2 minutes. \
prioritylist is list of the task numbers in order of priority. For example \
{3,1,2} would be used if task 3 has highest priority, followed by task 1, and \
then task 2. edges is the list of directed edges in the order-requirement \
digraph. Each edge is itself expressed as a list of length two, so edges is a \
nested list. For example {{1,2},{2,3}} would be used if there is an arrow \
from task 1 to task 2, and another arrow from task 2 to task 3. Lastly, \
processors is the number of processors to be used (a number such as 1, 2 or \
3). The option XReference can be set to a positive number. If two schedules \
have the same XReference value they will be rendered with the same horizontal \
scale. XReference should be set to a value near the maximum time needed for \
the schedules (the value will appear 400 printer's points from the left of \
the image). The option RectangleStyle can be set to a graphics directive (or \
to a list of such) to control the color, etc. of the solid rectangles in the \
schedule.";

ShowSchedulingDigraph::"usage"=
    "ShowSchedulingDigraph[tasktimes,edges] will render the order-requirement \
digraph with the given tasktimes and edges.The syntax for the two arguments \
is as follows: tasktimes is a list of times for the tasks. For instance, \
{3,5,2} would be used if there were three tasks, with task one taking 3 \
minutes, task two taking 5 minutes, and task three taking 2 minutes. edges is \
the list of directed edges in the order-requirement digraph. Each edge is \
itself expressed as a list of length two, so edges is a nested list. For \
example {{1,2},{2,3}} would be used if there is an arrow from task 1 to task \
2, and another arrow from task 2 to task 3. There are several options \
available. The option VertexRadius can be set to any positive number. The \
option VertexCoordinates may be set to a list of the {x,y} coordinates of \
each of the vertices (if you do not like the default choice). The option \
TaskOffset controls the placement of the Task labels for the vertices. It can \
be set to either a single value (the default is {2,-2}), or a list of such \
values, one for each individual vertex (if they need to be in different \
places). The option Levels may be set to 1 (default) or 2. These two settings \
result in different vertex placement when VertexCoordinates are not \
specified. The option setting Highlight->{1,3,4} will result in a graph with \
vertices 1, 3, and 4 highlighted, along with edges {1,3} and {3,4} (if these \
edges exist in the graph). Vertices in the Highlight list may appear more \
than once - this can be useful to enable multiple edges from a single vertex \
to be colored, for example. The option HighlightColor sets the color of the \
highlighted objects. Graphics options are also accepted.";

ScheduleTime::badsyntax=
    "Something is wrong with your input. The correct syntax can be found by \
typing ?ScheduleTime and hitting the Enter key.";

ShowSchedule::badsyntax=
    "Something is wrong with your input. The correct syntax can be found by \
typing ?ShowSchedule and hitting the Enter key.";

AllScheduleTimes::badsyntax=
    "Something is wrong with your input. The correct syntax can be found by \
typing ?AllScheduleTimes and hitting the Enter key.";

ScheduleTime::badarg=
    "Something is wrong with your input. Your list of task times (first \
argument) must have the same length as your priority list (second argument). \
The correct syntax can be found by typing ?ScheduleTime and hitting the Enter \
key.";

ShowSchedule::badarg=
    "Something is wrong with your input. Your list of task times (first \
argument) must have the same length as your priority list (second argument). \
The correct syntax can be found by typing ?ShowSchedule and hitting the Enter \
key.";

ShowSchedulingDigraph::badsyntax=
    "Something is wrong with your input. The correct syntax can be found by \
typing ?ShowSchedulingDigraph and hitting the Enter key.";



Options[AllScheduleTimes]:={Reminders\[Rule]True};

Options[RenderSchedule]:={
      TextStyle\[Rule]{FontSize\[Rule]14,FontFamily\[Rule]"Helvetica"},
      RectangleStyle\[Rule]RGBColor[.8,.3,.3],
      HighlightStyle\[Rule]Hue[.7,.5,.8],
      HighlightTasks\[Rule]{}
      };

Options[ShowSchedule]:={XReference\[Rule]Automatic};

Options[ver]:={
      DefaultColor\[Rule]GrayLevel[.8],
      HighlightColor\[Rule]RGBColor[.7,.8,.3]
      };

Options[ssdArrow]:={
      DefaultColor\[Rule]GrayLevel[0],
      HighlightColor\[Rule]RGBColor[.7,.8,.3]
      };

Options[ShowSchedulingDigraph]:={
      VertexRadius\[Rule]Automatic,
      TaskOffset\[Rule]{2,-2},
      VertexCoordinates\[Rule]Automatic,
      Highlight\[Rule]{},
      HighlightColor\[Rule]RGBColor[.7,.8,.3],
      Levels\[Rule]1
      };



Begin["`Private`"] (*---"RMCPackages`ListScheduling`Private`"---*)





(* frequencies is used by AllScheduleTimes to determine freq of the various \
sched times *)

frequencies[l_List]:=Map[{#,Count[l,#]}&,Union[l]];

(*ver is called by ShowSchedulingDigraph to render vertices*)

ver[coords_,wt_,tsk_,offset_List,radius_,color_,opts___Rule]:=
    Module[{dc,hc,
        selectedcolor},{dc,
          hc}={DefaultColor,HighlightColor}/.{opts}/.Options[ver];
      selectedcolor=Which[color\[Equal]1,hc,True,dc];
      Graphics[{{selectedcolor,
            Disk[coords,radius]},{Circle[coords,radius]},{Text[wt,coords,
              TextStyle\[Rule]{FontSize\[Rule]14,
                  FontFamily\[Rule]"Helvetica"}]},{Text[tsk,coords,offset,
              TextStyle\[Rule]{FontSize\[Rule]14,
                  FontFamily\[Rule]"Helvetica"}]}},
        AspectRatio\[Rule]Automatic]];

(*ssdArrow is used by ShowSchedulingDigraph to draw the directed edges.*)

ssdArrow[{v1_,v2_},vlist_List,radius_,color_,opts___Rule]:=
  Module[{dc,hc,selectedcolor,start,end,
      w},{dc,hc}={DefaultColor,HighlightColor}/.{opts}/.Options[ssdArrow];
    selectedcolor=Which[color\[Equal]1,hc,True,dc];
    start=vlist[[v1]];
    end=vlist[[v2]];
    w=N[end-start];
    w=radius*w/Sqrt[w.w];(*vec from v1 toward v2 of magnitude radius*)
    
    start=start+w;
    end=end-w;
    Graphics[{selectedcolor,Arrow[start,end,HeadLength\[Rule].025]}]]



LPA[times_,pl_,ed_,processors_]:=
  Module[{schedule,schedtimes,plist=pl,edges=ed,totaltimes={0},
      availprocessors,nextprocessor,currenttime,numcompleted,complete,ready,
      nexttask,k,n,i,idle},schedule=Table[{},{processors}];
    schedtimes=Table[{0},{processors}];
    While[plist=!={}||Max[totaltimes]>Min[totaltimes],
      availprocessors=Flatten[Position[totaltimes,Min[totaltimes]]];
      nextprocessor=First[availprocessors];
      currenttime=Last[schedtimes[[nextprocessor]]];
      numcompleted=
        Map[Length[Select[#,(#\[LessEqual]currenttime)&]]-1&,schedtimes];
      complete=Flatten[MapThread[Take,{schedule,numcompleted}]];
      edges=Select[edges,Not[MemberQ[complete,#[[1]]]]&];
      ready=Select[plist,Not[MemberQ[edges[[All,2]],#]]&];
      If[Length[ready]>0,(*assign nexttask to nextprocessor*)nexttask=
          ready[[1]];
        schedule[[nextprocessor]]=
          Flatten[{schedule[[nextprocessor]],nexttask}];
        schedtimes[[nextprocessor]]=
          Flatten[{schedtimes[[nextprocessor]],
              times[[nexttask]]+
                Last[schedtimes[[nextprocessor]]]}],(*ELSE assign idle time \
to availprocessors*)
        
        nexttime=Sort[Union[totaltimes]][[2]];(*2nd time must exist*)
        
        Do[k=availprocessors[[i]];
          
          If[(schedule[[k]]=!={}&&Last[schedule[[k]]]=!=idle)||
              schedule[[k]]\[Equal]{},(*assign idle time to processor k*)
    
                    schedule[[k]]=Flatten[{schedule[[k]],idle}];
            
            schedtimes[[k]]=
              Flatten[{schedtimes[[k]],
                  nexttime}],(*ELSE consolodate adjacent idle times*)
        
                n=Length[schedtimes[[k]]];
            schedtimes[[k,n]]=nexttime],{i,Length[availprocessors]}]];
      plist=Select[plist,Not[MemberQ[Flatten[schedule],#]]&];
      totaltimes=Table[Last[schedtimes[[i]]],{i,processors}]];
    {schedule,schedtimes}]

ScheduleTime[times_List?(Depth[#]\[Equal]2&),pl_List?(Depth[#]\[Equal]2&),
    ed_List?(Depth[#]\[Equal]3||#\[Equal]{}&),processors_Integer?Positive]:=
  Module[{},
    If[Length[times]=!=Length[pl],Message[ScheduleTime::badarg];Return[]];
    Max[Last/@LPA[times,pl,ed,processors][[2]]]]

ScheduleTime[___]:=Message[ScheduleTime::badsyntax]

ShowSchedule[times_List?(Depth[#]\[Equal]2&),pl_List?(Depth[#]\[Equal]2&),
    ed_List?(Depth[#]\[Equal]3||#\[Equal]{}&),processors_Integer?Positive,
    opts___Rule]:=
  Module[{xr},If[Length[times]=!=Length[pl],Message[ShowSchedule::badarg];
      Return[]];
    xr=XReference/.{opts}/.Options[ShowSchedule];
    If[xr===Automatic,xr=Ceiling[Apply[Plus,times]/processors]];
    (*lower-bnd on total time,so same x-scale is used for all priority lists*)
      RenderSchedule[LPA[times,pl,ed,processors],xr,opts]]

ShowSchedule[___]:=Message[ShowSchedule::badsyntax]

\!\(RenderSchedule[{schedule_, schedtimes_}, lb_, opts___Rule] := 
    Module[{rs, hs, ht, ts, p, xtics, ytics, xmax, recs, reclabels, hlines, 
        vlines = {}}, {rs, hs, ts, 
          ht} = \({RectangleStyle, HighlightStyle, TextStyle, 
              HighlightTasks} /. {opts}\) /. 
          Options[RenderSchedule]; \[IndentingNewLine]rs = 
        Switch[rs, _List, rs, _, List[rs]]; \[IndentingNewLine]hs = 
        Switch[hs, _List, hs, _, List[hs]]; \[IndentingNewLine]p = 
        Length[schedule]; \[IndentingNewLine]ytics = 
        Map[Text[#, {\(- .8\), \(-#\) +  .5}] &, 
          Range[p]]; \[IndentingNewLine]xtics = 
        Drop[Union[Flatten[schedtimes]], 1]; \[IndentingNewLine]xmax = 
        Last[xtics]; \[IndentingNewLine]xticlines = 
        Map[Line[{{#, \(-p\)}, {#, \(-p\) -  .1}}] &, 
          xtics]; \[IndentingNewLine]xtics = 
        Map[Text[#, {#, \(-p\) -  .3}] &, xtics]; \[IndentingNewLine]recs = 
        Map[Rectangle[{schedtimes[\([#[\([1]\)], #[\([2]\)]]\)], \
\(-#[\([1]\)]\)}, {schedtimes[\([#[\([1]\)], #[\([2]\)] + 
                      1]\)], \(-#[\([1]\)]\) + 1}] &, 
          Position[schedule, _?NumericQ, 2]]; \[IndentingNewLine]hrecs = 
        Extract[recs, 
          Position[
            Cases[schedule, _?NumericQ, 
              2], _?\((MemberQ[ht, #] &)\)]]; \[IndentingNewLine]recs = 
        Join[rs, Complement[recs, hrecs]]; \[IndentingNewLine]hrecs = 
        If[Length[hrecs] > 0, 
          Join[hs, 
            hrecs], {}]; \[IndentingNewLine]reclabels = \
\((Text["\<T\>"\_\(schedule\[LeftDoubleBracket]#1\[LeftDoubleBracket]1\
\[RightDoubleBracket], #1\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket]\), { .5\ \((schedtimes\[LeftDoubleBracket]#1\
\[LeftDoubleBracket]1\[RightDoubleBracket], #1\[LeftDoubleBracket]2\
\[RightDoubleBracket] + 1\[RightDoubleBracket] + 
                        schedtimes\[LeftDoubleBracket]#1\[LeftDoubleBracket]1\
\[RightDoubleBracket], #1\[LeftDoubleBracket]2\[RightDoubleBracket]\
\[RightDoubleBracket])\),  .5 - \
#1\[LeftDoubleBracket]1\[RightDoubleBracket]}, TextStyle \[Rule] ts] &)\) /@ 
          Position[schedule, _?NumericQ, 2]; \[IndentingNewLine]hlines = 
        Map[Line[{{0, \(-#\)}, {xmax, \(-#\)}}] &, 
          Range[0, p]]; \[IndentingNewLine]Do[
        vlines = 
          Append[vlines, 
            Line[{{schedtimes[\([i, j]\)], \(-i\)}, {schedtimes[\([i, 
                      j]\)], \(-i\) + 1}}]], {i, p}, {j, 
          Length[schedule[\([i]\)]]}]; \[IndentingNewLine]vlines = 
        Append[vlines, 
          Line[{{xmax, \(-p\)}, {xmax, 0}}]]; \[IndentingNewLine]Show[
        Graphics[recs], Graphics[hrecs], Graphics[xtics], 
        Graphics[xticlines], Graphics[ytics], Graphics[reclabels], 
        Graphics[hlines], Graphics[vlines], 
        Evaluate[FilterOptions[Graphics, opts]], 
        ImageSize \[Rule] {400*xmax/lb, p*80}, 
        AspectRatio \[Rule] p*lb/\((5*xmax)\)]]\)

AllScheduleTimes[times_List?(Depth[#]\[Equal]2&),
    edges_List?(Depth[#]\[Equal]3||#\[Equal]{}&),processors_Integer?Positive,
    opts___Rule]:=
  Module[{rem,n,plists,t,k},rem=Reminders/.{opts}/.Options[AllScheduleTimes];
    If[rem,Print["task times = ",times,"."];
      Print["edges = ",edges,"."];
      Print["number of processors = ",processors,"."]];
    n=Length[times];
    plists=Permutations[Range[n]];
    t=Table[ScheduleTime[times,plists[[k]],edges,processors],{k,1,n!}];
    TableForm[frequencies[t],
      TableHeadings\[Rule]{None,{"Schedule Time","Frequency"}}]]

AllScheduleTimes[___]:=Message[AllScheduleTimes::badsyntax]

\!\(ShowSchedulingDigraph[times_List?\((Depth[#1] \[Equal] 2 &)\), 
      edges_List?\((Depth[#1] \[Equal] 3 || #1 \[Equal] {} &)\), 
      opts___Rule] := 
    Module[{vr, to, vc, hl, hlc, lev, n, r, g, xcoords, leftvertices, v, k, 
        hv, he, vgraphics, 
        egraphics}, {vr, to, vc, hl, hlc, 
          lev} = \({VertexRadius, TaskOffset, VertexCoordinates, Highlight, 
              HighlightColor, 
              Levels} /. \[InvisibleSpace]{opts}\) \
/. \[InvisibleSpace]Options[ShowSchedulingDigraph]; \[IndentingNewLine]lev = 
        Switch[lev, 1, 1, _, 2]; \[IndentingNewLine]n = 
        Length[times]; \[IndentingNewLine]r = Range[n]; \[IndentingNewLine]If[
        Depth[to] \[Equal] 2, to = Table[to, {n}]]; 
      If[vc === Automatic, 
        g = MakeUndirected[MakeGraph[r, MemberQ[edges, {#1, #2}] &]]; 
        leftvertices = 
          Complement[r, 
            edges\[LeftDoubleBracket]All, lev\[RightDoubleBracket]]; 
        vc = Vertices[RankedEmbedding[g, leftvertices]]; 
        If[lev \[Equal] 1, 
          xcoords = vc\[LeftDoubleBracket]All, 1\[RightDoubleBracket]; 
          vc\[LeftDoubleBracket]All, 1\[RightDoubleBracket] = 
            0.5\ \((Max[xcoords] - Min[xcoords])\) - xcoords]]; 
      If[vr === Automatic, 
        xcoords = vc\[LeftDoubleBracket]All, 1\[RightDoubleBracket]; 
        vr = \(Max[xcoords] - Min[xcoords]\)\/25. ]; \[IndentingNewLine]hv = 
        MapAt[1 &, Table[0, {n}], Partition[hl, 1]]; 
      vgraphics = 
        Table[ver[vc\[LeftDoubleBracket]k\[RightDoubleBracket], 
            times\[LeftDoubleBracket]k\[RightDoubleBracket], "\<T\>"\_k, 
            to\[LeftDoubleBracket]k\[RightDoubleBracket], vr, 
            hv\[LeftDoubleBracket]k\[RightDoubleBracket], 
            HighlightColor \[Rule] hlc], {k, n}]; 
      he = Table[0, {Length[edges]}]; 
      he = MapAt[1 &, he, 
          Flatten[\((Position[edges, #1] &)\) /@ Partition[hl, 2, 1], 1]]; 
      egraphics = 
        Table[ssdArrow[edges\[LeftDoubleBracket]k\[RightDoubleBracket], vc, 
            vr, he\[LeftDoubleBracket]k\[RightDoubleBracket], 
            HighlightColor \[Rule] hlc], {k, Length[edges]}]; 
      Show[vgraphics, egraphics, Evaluate[FilterOptions[Graphics, opts]], 
        PlotRange \[Rule] All, ImageSize \[Rule] 500, 
        AspectRatio \[Rule] Automatic]]\)

ShowSchedule[___]:=Message[ShowSchedulingDigraph::badsyntax]



End[]	(* end the private context *)



Protect[AllScheduleTimes,LPA,RenderSchedule,ScheduleTime,ShowSchedule,\
ShowSchedulingDigraph] 

EndPackage[] 	(* end the package context *)