(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)







BeginPackage["RMCPackages`Popcorn`",{"Utilities`FilterOptions`"}]



Popcorn::usage = 
"Popcorn[n] returns a graphic depicting a popcorn popper from above, having \
popped n kernels without a lid. A table showing how many kernels landed \
within a certain radius of the popper is also displayed. Popcorn[n,\[Lambda]] \
does the same, using the Poisson parameter \[Lambda]. The default value for \
\[Lambda] is .35. Popcorn accepts Graphics options, such as ImageSize and \
Background.";

KernelStyle::usage = 
"KernelStyle is an option for Popcorn that controls the appearance of \
individual popcorn kernels (each is a Point). Set it to a Graphics directive \
or to a list of such directives.";

PopperStyle::usage = 
"PopperStyle is an option for Popcorn that controls the appearance of the \
popper (a Disk) in the center of the image. Set it to a Graphics directive or \
to a list of such directives.";

Popcorn::BadRings="Sorry, but you need a positive number of rings.";

Popcorn::BadParameter=
    "Sorry, but the second argument must be a number strictly between 0 and \
1.";



Options[Popcorn]:={
      KernelStyle\[Rule]{PointSize[.01],Hue[.12,.52,.94]},
      PopperStyle\[Rule]{Hue[.7,.8,.5]},
      Rings\[Rule]Automatic
      };



Begin["`Private`"]



makelist[object_]:=Switch[object,_List,object,_,List[object]];

sf[a_,font_String,size_]:=
  StyleForm[a,FontFamily\[Rule]font,FontSize\[Rule]ToString[size]]

sf[a_]:=sf[a,"Helvetica",10]



Popcorn[m_,lamda__?NumericQ,opts___?OptionQ]:=
  Module[{dir,rad,freq,q,max,backdrop,popper,ks,ps},
    If[lamda\[LessEqual]0||lamda\[GreaterEqual]1,
      Return[Message[Popcorn::BadParameter]]];
    {ks,ps,max}={KernelStyle,PopperStyle,Rings}/.{opts}/.Options[Popcorn];
    dir=2\[Pi]*Table[Random[],{m}]; (* direction for each kernel *)
    
    rad=Table[Log[lamda,Random[]],{m}];(* radius for each kernel *)
    
    Which[max===Automatic,max=Ceiling[Max[rad]],
      max\[LessEqual]0,Return[Message[Popcorn::BadRings]]];
    freq=Table[Length[Cases[rad,_?(q-1<=#<q&)]],{q,max}];
    (* frequencies: no. of kernels between two consecutive bands *)
    
    backdrop=Graphics[Prepend[Table[Circle[{0,0},q],{q,max}],GrayLevel[0]]];
    popper=Graphics[Join[makelist[ps],{Disk[{0,0},.2]}]];
    corn=Graphics[Join[makelist[ks],Point/@(rad*({Cos[#],Sin[#]}&/@dir))]];
    Show[backdrop,popper,corn,
      FilterOptions[Graphics,opts]//Evaluate,
      AspectRatio\[Rule]Automatic,
      PlotRange\[Rule]{1.1{-max,max},1.1{-max,max}},ImageSize\[Rule]350,
      Background\[Rule]Hue[.7,.3,.7]];
    TableForm[{Range[max],freq},
      TableHeadings\[Rule]{{sf["Distance"],sf["No. of Kernels"]},None}]
    ]

Popcorn[m_,opts___?OptionQ]:=Popcorn[m,.35,opts]



End[]	(* end the private context *)

Protect[Popcorn,KernelStyle,PopperStyle,Rings]

EndPackage[] 	(* end the package context *)