(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









BeginPackage["RMCPackages`ShowColors`",{"Graphics`Colors`",
    "Utilities`FilterOptions`"}]



ShowColors::usage = 
"ShowColors[] returns a graphic showing a color swatch and the associated \
color name for each of the colors available in the standard package \
Graphics`Colors`.ShowColors[n] returns only those colors whose names have n \
or fewer characters. ShowColors[string] produces color swatches for those \
colors whose names contain the given string (note that string must be \
enclosed in double quotes).";

ShowColors::igotnuthin=
    "Sorry, no colors match that criteria. Remember to capitalize, e.g. Blue \
instead of blue.";



Options[ShowColors]:={
      Columns\[Rule]Automatic,
      FontFamily\[Rule]"Helvetica",
      FontSize\[Rule]Automatic
      };



Begin["`Private`"]



ac=AllColors;

sf[a_,font_String,size_]:=
  StyleForm[a,FontFamily\[Rule]font,FontSize\[Rule]ToString[size]]

entry[name_String,font_,size_]:=
    Graphics[{{ToExpression[name],
          Rectangle[{-1,-1},{1,1}]},{Text[
            sf[name,font,size],{1.1,0},{-1,0}]}},
      PlotRange\[Rule]{{-1,20},Automatic},AspectRatio\[Rule]Automatic];

entry[0,font_,size_]=Graphics[{GrayLevel[1],Point[{0,0}]}]; (* 
  show nothing in final entries of incomplete last column *)

supplement[l_List,n_Integer?Positive]:=
  Join[l,Table[0,{Mod[n-Mod[Length[l],n],n]}]]
(* make length of l a multiple of n, for n columns of equal length *)

check[name_String,text_String]:=StringMatchQ[name,"*"<>text<>"*"]



ShowColors[subset_List,opts___?OptionQ]:=
    Module[{supp ,cols,font,size,n=Length[subset]},
      {cols,font,
          size}={Columns,FontFamily,FontSize}/.{opts}/.Options[ShowColors];
      If[cols===Automatic,Which[
          n<3,cols=2,
          n<52,cols=3,
          True,cols=4]];
      If[size===Automatic,Which[
          n<52,size=12,
          True,size=10]];
      supp=supplement[subset,cols];
      Show[GraphicsArray[
          Transpose[Partition[entry[#,font,size]&/@supp,Length[supp]/cols]]],
        ImageSize\[Rule]600,FilterOptions[Graphics,opts]//Evaluate]
      ];

ShowColors[opts___?OptionQ]:=ShowColors[ac,opts]

ShowColors[n_Integer?Positive,opts___?OptionQ]:=Module[{x,positions,subset},
      positions=Flatten[Position[Map[StringLength,ac],x_ /; x\[LessEqual]n]];
      subset=ac[[#]]&/@positions;
      Which[Length[subset]>0,ShowColors[subset,opts],
        True,Return[Message[ShowColors::igotnuthin]]]
      ];

ShowColors[text_String,opts___?OptionQ]:=Module[{positions,subset},
      positions=Flatten[Position[Map[check[#,text]&,ac],True]];
      subset=ac[[#]]&/@positions;
      Which[Length[subset]>0,ShowColors[subset,opts],
        True,Return[Message[ShowColors::igotnuthin]]]
      ];



End[]	(* end the private context *)

Protect[ShowColors]

EndPackage[] 	(* end the package context *)