(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)







BeginPackage["RMCPackages`Spirograph`","Utilities`FilterOptions`"]



Spirograph::usage = 
"Spirograph[{a,b},n] returns a graphic showing the cycloid (spirograph) \
obtained by rolling a circle of radius b around a fixed circle of radius a \
exactly n times. The initial configuration has the fixed circle centered at \
the origin and the point of tangency at (a,0). The tracing point is on the \
edge of the rolling circle, and is initially at the point of tangency. The \
simpler syntax Spirograph[{a,b}] will produce a graphic that will show enough \
rotations to close the curve (provided a and b are rational numbers). \
Spirograph[{a,b,c},n] will do the same, but with the tracing point located c \
units from the center of the rolling circle. As before, the second argument n \
may be omitted. Spirograph[{a,b},{t0,t1}] or Spirograph[{a,b,c},{t0,t1}] will \
produce that portion of the spirograph curve where the central angle formed \
by the segment joining the centers of the two circles ranges from t0 to t1 \
radians. Spirograph will accept any options accepted by ParametricPlot. In \
particular, PlotPoints may need to be set to a relatively large value (200 or \
even higher) in order to accurately render a complex graphic.";

SpirographCircles::usage = 
"SpirographCircles[{a,b},t] returns a graphic showing the fixed circle of \
radius a and the rolling circle of radius b at that moment when the segment \
joining the centers of the two circles is at t radians (measured \
counterclockwise from the positive x axis). SpirographCircles[{a,b,c},t] does \
the same, but makes the radial line on the rolling circle exactly c units in \
length. Several options may be used to control the appearance of the various \
parts of the image: FixedCircleStyle, RollingCircleStyle, \
RollingCircleRadiusStyle, RollingCircleCenterStyle, and \
RollingCircleTracepointStyle. Each of these may be set to a Graphics \
directive or to a list of such directives.";

SpirographMovie::usage = 
"SpirographMovie[{a,b},n] returns an animation showing the cycloid \
(spirograph) obtained by rolling a circle of radius b around a fixed circle \
of radius a exactly n times. The initial configuration has the fixed circle \
centered at the origin and the point of tangency at (a,0). The tracing point \
is on the edge of the rolling circle, and is initially at the point of \
tangency. The simpler syntax SpirographMovie[{a,b}] will produce a graphic \
that will show enough rotations to close the curve (provided a and b are \
rational numbers). SpirographMovie[{a,b,c},n] will do the same, but with the \
tracing point located c units from the center of the rolling circle. As \
before, the second argument n may be omitted. SpirographMovie[{a,b},{t0,t1}] \
or Spirograph[{a,b,c},{t0,t1}] will produce an animation of that portion of \
the spirograph curve where the central angle formed by the segment joining \
the centers of the two circles ranges from t0 to t1 radians. Spirograph will \
accept any Graphics options. In addition, the option Frames controls the \
number of frames in the final movie. Things will run faster when Frames is \
set to a lower value, but things will look nicer when it is set to a high \
value. The option PointsPerFrame controls the smoothness of the cycloid \
curve. It is set to 4 by default; a higher value will smooth out the curve \
irrespective of how many frames are in the final movie. For those who might \
care, the setting of PointsPerFrame is the number of points sampled on the \
spirograph curve between each pair of consecutive frames of the movie. \
Finally, SpirographMovie will accept any option accepted by SpirographCircles \
- in particular, there are options to controlt the style of the various \
components of the image: FixedCircleStyle, RollingCircleStyle, \
RollingCircleRadiusStyle, RollingCircleCenterStyle, and \
RollingCircleTracepointStyle. Each of these may be set to a Graphics \
directive or to a list of such directives.";

SpirographMovieGraphics::usage = 
"SpirographMovieGraphics[args] returns a list of the graphics in the \
animation SpirographMovie[args]. This command is useful for producing \
graphics arrays that can be used in print to illustrate the movie. For \
instance, try entering: \
pics=SpirographMovieGraphics[{3,-1},Frames\[Rule]7,PointsPerFrame\[Rule]50]. \
And then enter: Show[GraphicsArray[Partition[pics,4]]]. This command is also \
useful for converting an animation into an animated GIF for use on a web \
page. Look up Export for details.";

FixedCircleStyle::usage = 
"FixedCircleStyle is an option for SpirographCircles and SpirographMovie. It \
controls the appearance of the fixed circle, and may be set to a Graphics \
directive or to a list of such directives.";

RollingCircleStyle::usage = 
"RollingCircleStyle is an option for SpirographCircles and SpirographMovie. \
It controls the appearance of the rolling circle, and may be set to a \
Graphics directive or to a list of such directives.";

RollingCircleRadiusStyle::usage = 
"RollingCircleRadiusStyle is an option for SpirographCircles and \
SpirographMovie. It controls the appearance of the radial line on the rolling \
circle, and may be set to a Graphics directive or to a list of such \
directives.";

RollingCircleCenterStyle::usage = 
"RollingCircleCenterStyle is an option for SpirographCircles and \
SpirographMovie. It controls the appearance of the point at the center of the \
rolling circle, and may be set to a Graphics directive or to a list of such \
directives.";

RollingCircleTracepointStyle::usage = 
"RollingCircleTracepointStyle is an option for SpirographCircles and \
SpirographMovie. It controls the appearance of the tracing point on the \
rolling circle, and may be set to a Graphics directive or to a list of such \
directives.";

Frames::usage = 
"Frames is an option for SpirographMovie. It controls the number of frames in \
the final animation.";

PointsPerFrame::usage = 
"PointsPerFrame is an option for SpirographMovie. It controls the number of \
points sampled for the rendering of each portion of the spirograph curve \
produced in successive frames in the animation.";



Options[Spirograph]:={PlotStyle\[Rule]Hue[1]};

Options[SpirographCircles]:={
      FixedCircleStyle\[Rule]{},
      RollingCircleStyle\[Rule]Hue[.7],
      RollingCircleRadiusStyle\[Rule]{},
      RollingCircleCenterStyle\[Rule]{PointSize[.02],Hue[.7]},
      RollingCircleTracepointStyle\[Rule]{PointSize[.02],Hue[1]}
      };

Options[SpirographMovie]={Frames\[Rule]Automatic,PointsPerFrame\[Rule]3};



Begin["`Private`"]



makelist[object_]:=Switch[object,_List,object,_,List[object]];

SpirographValue[a_?NumericQ,b_?NumericQ,c_?NumericQ,
      t_?NumericQ]:={(a+b)Cos[t]-c*Cos[(a+b)t/b],(a+b)Sin[t]-c Sin[(a+b)t/b]};



Spirograph[{a_?NumericQ,b_?NumericQ,c_?NumericQ},{t0_?NumericQ,t1_?NumericQ},
      opts___?OptionQ]:=Module[{m=1.1Max[a,a+2b],range,ps},
      range={{-m,m},{-m,m}};
      ps=PlotStyle/.{opts}/.Options[Spirograph];
      ParametricPlot[SpirographValue[a,b,c,t]//Evaluate,{t,t0,t1},
        PlotStyle->ps,PlotRange\[Rule]range,Axes\[Rule]False,
        AspectRatio\[Rule]1,opts]
      ];

Spirograph[{a_?NumericQ,b_?NumericQ},{t0_?NumericQ,t1_?NumericQ},
    opts___?OptionQ]:=Spirograph[{a,b,b},{t0,t1},opts]

Spirograph[{a_?NumericQ,b_?NumericQ,c_?NumericQ},n_?NumericQ,opts___?OptionQ]:=
  Spirograph[{a,b,c},{0,2\[Pi] n},opts]

Spirograph[{a_?NumericQ,b_?NumericQ},n_?NumericQ,opts___?OptionQ]:=
  Spirograph[{a,b,b},{0,2\[Pi] n},opts]

Spirograph[{a_?NumericQ,b_?NumericQ,c_?NumericQ},opts___?OptionQ]:=
  Spirograph[{a,b,c},Denominator[a/b],opts]

Spirograph[{a_?NumericQ,b_?NumericQ},opts___?OptionQ]:=
  Spirograph[{a,b,b},Denominator[a/b],opts]

SpirographCircles[{a_?NumericQ,b_?NumericQ,c_?NumericQ},t_?NumericQ,
    opts___?OptionQ]:=
  Module[{m=1.1Max[a,a+2b],range,fcs,rcs,rcrs,rccs,rcts,cp,tp},
    range={{-m,m},{-m,m}};
    fcs=FixedCircleStyle/.{opts}/.Options[SpirographCircles];
    rcs=RollingCircleStyle/.{opts}/.Options[SpirographCircles];
    rcrs=RollingCircleRadiusStyle/.{opts}/.Options[SpirographCircles];
    rccs=RollingCircleCenterStyle/.{opts}/.Options[SpirographCircles];
    rcts=RollingCircleTracepointStyle/.{opts}/.Options[SpirographCircles];
    cp={(a+b)Cos[t],(a+b)Sin[t]};
    tp=SpirographValue[a,b,c,t];
    Graphics[{
        Append[makelist[fcs],Circle[{0,0},Abs[a]]],
        Append[makelist[rcs],Circle[cp,Abs[b]]],
        Append[makelist[rcrs],Line[{cp,tp}]],
        Append[makelist[rccs],Point[cp]],
        Append[makelist[rcts],Point[tp]]
        },PlotRange\[Rule]range,AspectRatio\[Rule]1,
      FilterOptions[Graphics,opts]//Evaluate]
    ]

SpirographCircles[{a_?NumericQ,b_?NumericQ},t_?NumericQ,opts___?OptionQ]:=
  SpirographCircles[{a,b,b},t,opts]

SpirographMovie[{a_?NumericQ,b_?NumericQ,c_?NumericQ},{t0_?NumericQ,
      t1_?NumericQ},opts___?OptionQ]:=
  Module[{m=1.1Max[a,a+2b],range,ps,fcs,rcs,rcrs,rccs,rcts,ppf,fr,dt,sp={}},
    range={{-m,m},{-m,m}};
    ps=PlotStyle/.{opts}/.Options[Spirograph];
    fcs=FixedCircleStyle/.{opts}/.Options[SpirographCircles];
    rcs=RollingCircleStyle/.{opts}/.Options[SpirographCircles];
    rcrs=RollingCircleRadiusStyle/.{opts}/.Options[SpirographCircles];
    rccs=RollingCircleCenterStyle/.{opts}/.Options[SpirographCircles];
    rcts=RollingCircleTracepointStyle/.{opts}/.Options[SpirographCircles];
    ppf=PointsPerFrame/.{opts}/.Options[SpirographMovie];
    fr=Frames/.{opts}/.Options[SpirographMovie];
    If[fr===Automatic,fr=Max[2,Round[2Max[Abs[a/b],Abs[b/a]](t1-t0)]]];
    dt=(t1-t0)/(fr-1);
    Do[
      Show[
        Graphics[{Append[makelist[ps],Line[sp]]}],
        SpirographCircles[{a,b,c},t,FixedCircleStyle\[Rule]fcs,
          RollingCircleStyle\[Rule]rcs,RollingCircleRadiusStyle\[Rule]rcrs,
          RollingCircleCenterStyle\[Rule]rccs,
          RollingCircleTracepointStyle\[Rule]rcts],
        PlotRange\[Rule]range,AspectRatio\[Rule]1,
        FilterOptions[Graphics,opts]//Evaluate
        ];
      sp=Join[sp,Table[SpirographValue[a,b,c,i],{i,t,t+dt,dt/ppf}]],
      {t,t0,t1,dt}]
    ]

SpirographMovie[{a_?NumericQ,b_?NumericQ},{t0_?NumericQ,t1_?NumericQ},
    opts___?OptionQ]:=SpirographMovie[{a,b,b},{t0,t1},opts]

SpirographMovie[{a_?NumericQ,b_?NumericQ,c_?NumericQ},n_?NumericQ,
    opts___?OptionQ]:=SpirographMovie[{a,b,c},{0,2\[Pi] n},opts]

SpirographMovie[{a_?NumericQ,b_?NumericQ},n_?NumericQ,opts___?OptionQ]:=
  SpirographMovie[{a,b,b},{0,2\[Pi] n},opts]

SpirographMovie[{a_?NumericQ,b_?NumericQ,c_?NumericQ},opts___?OptionQ]:=
  SpirographMovie[{a,b,c},Denominator[a/b],opts]

SpirographMovie[{a_?NumericQ,b_?NumericQ},opts___?OptionQ]:=
  SpirographMovie[{a,b,b},Denominator[a/b],opts]

SpirographMovieGraphics[{a_?NumericQ,b_?NumericQ,c_?NumericQ},{t0_?NumericQ,
      t1_?NumericQ},opts___?OptionQ]:=
  Module[{m=1.1Max[a,a+2b],range,ps,fcs,rcs,rcrs,rccs,rcts,ppf,fr,dt,sp={},
      graphicslist={}},
    range={{-m,m},{-m,m}};
    ps=PlotStyle/.{opts}/.Options[Spirograph];
    fcs=FixedCircleStyle/.{opts}/.Options[SpirographCircles];
    rcs=RollingCircleStyle/.{opts}/.Options[SpirographCircles];
    rcrs=RollingCircleRadiusStyle/.{opts}/.Options[SpirographCircles];
    rccs=RollingCircleCenterStyle/.{opts}/.Options[SpirographCircles];
    rcts=RollingCircleTracepointStyle/.{opts}/.Options[SpirographCircles];
    ppf=PointsPerFrame/.{opts}/.Options[SpirographMovie];
    fr=Frames/.{opts}/.Options[SpirographMovie];
    If[fr===Automatic,fr=Round[2Max[a/b,b/a](t1-t0)]];
    dt=(t1-t0)/(fr-1);
    Do[AppendTo[graphicslist,Show[
          
          Graphics[{Append[makelist[ps],Line[sp]]},PlotRange\[Rule]range,
            AspectRatio\[Rule]1,FilterOptions[Graphics,opts]//Evaluate],
          SpirographCircles[{a,b,c},t,
            DisplayFunction\[Rule]Identity,
            FixedCircleStyle\[Rule]fcs,
            RollingCircleStyle\[Rule]rcs,
            RollingCircleRadiusStyle\[Rule]rcrs,
            RollingCircleCenterStyle\[Rule]rccs,
            RollingCircleTracepointStyle\[Rule]rcts],
          DisplayFunction\[Rule]Identity]
        ];
      sp=Join[sp,Table[SpirographValue[a,b,c,i],{i,t,t+dt,dt/ppf}]],
      {t,t0,t1,dt}];
    graphicslist
    ]

SpirographMovieGraphics[{a_?NumericQ,b_?NumericQ},{t0_?NumericQ,t1_?NumericQ},
    opts___?OptionQ]:=SpirographMovieGraphics[{a,b,b},{t0,t1},opts]

SpirographMovieGraphics[{a_?NumericQ,b_?NumericQ,c_?NumericQ},n_?NumericQ,
    opts___?OptionQ]:=SpirographMovieGraphics[{a,b,c},{0,2\[Pi] n},opts]

SpirographMovieGraphics[{a_?NumericQ,b_?NumericQ},n_?NumericQ,
    opts___?OptionQ]:=SpirographMovieGraphics[{a,b,b},{0,2\[Pi] n},opts]

SpirographMovieGraphics[{a_?NumericQ,b_?NumericQ,c_?NumericQ},
    opts___?OptionQ]:=SpirographMovieGraphics[{a,b,c},Denominator[a/b],opts]

SpirographMovieGraphics[{a_?NumericQ,b_?NumericQ},opts___?OptionQ]:=
  SpirographMovieGraphics[{a,b,b},Denominator[a/b],opts]



End[]	(* end the private context *)

Protect[Spirograph,SpirographCircles,SpirographMovie,SpirographMovieGraphics]

EndPackage[] 	(* end the package context *)

