(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(************************************
    
    By Bruce Torrence, Dec.2002. 
      Updated  Oct. 16, 2004
  
  ************************************)


BeginPackage["RMCPackages`TaylorTools`",
  {"Utilities`FilterOptions`","RMCPackages`SliceSurface`"}]



TaylorPolynomial::usage=
    "TaylorPolynomial[f[x],x,x0,n] returns the Taylor polynomial for f[x] \
expanded around the point x=x0, and of degree n. \
TaylorPolynomial[f[x,y,...],{x,y,...},{x0,y0,...},n] returns the Taylor \
polynomial for f[x,y,...] expanded around the point {x0,y0,...}, and of \
degree n. If the point of expansion is omitted, the function is exapanded \
about the origin. If the degree n is omitted, the first degree polynomial is \
returned.";

TaylorPolynomialTerms::usage=
    "TaylorPolynomialTerms[f[x,y,...],{x,y,...},{x0,y0,...},n] returns a list \
of the summands of the Taylor polynomial for f[x,y,...] expanded around the \
point {x0,y0,...}, and of degree n. The list is sorted according to the total \
degree of the summands. In other words, the first item in the list is the \
constant term, the second item is the sum of all terms of degree 1, the third \
is the sum of all the terms of total degree 2, and so on. If the point of \
expansion is omitted, the function is exapanded about the origin. If the \
degree n is omitted, the first degree polynomial is returned.";

TaylorPlot::usage=
    "TaylorPlot[f[x], {x, xmin, xmax}, x0, n] returns the Taylor polynomial \
of degree n expanded around the point x0, together with a plot of both f and \
the Taylor polynomial. If x0 is omitted from the input the polynomial is \
expanded about the midpoint of xmin and xmax. If in addition n is omitted, \
the linear polynomial is used. The option Radius controls the size of the \
Taylor plot, while the option TaylorPlotStyle can be used to set Graphics \
directives for the Taylor plot. The point {x0,f[x0]} will be rendered \
according the setting of the option PointStyle.";

TaylorPlot3D::usage=
    "TaylorPlot3D[f[x,y], {x, xmin, xmax},{y, ymin, ymax}, {x0,y0}, n] \
returns the Taylor polynomial of degree n expanded around the point {x0,y0},  \
together with a plot of both f (solid) and the Taylor polynomial (wireframe). \
If {x0,y0} is omitted from the input the polynomial is expanded about the \
center of the domain. If in addition n is omitted, the linear polynomial is \
used. The option Float->0.01 will lift the wireframe plot up just enough to \
allow for a better rendering in some instances. The option Radius controls \
the size of the wireframe plot relative to the solid plot (set to 0.5 by \
default), and the option PointStyle can be used to set Graphics3D directives \
for the rendering of the point {x0,y0,f[x0,y0]}. The option TaylorPlotStyle \
controls the rendering of the wireframe segments.";

Radius::usage=
    "Radius is an option for TaylorPlot and TaylorPlot3D. It scales the size \
of the Taylor polynomial plot relative to the size of the plot of the \
function iteself. A setting of .5 results in a Taylor plot half the size of \
the function plot. It can be set to a positive number (or to a list of two \
positive numbers{xradius, yradius} when used in TaylorPlot3D).";

TaylorPlotStyle::usage=
    "TaylorPlotStyle is an option for TaylorPlot and TaylorPlot3D. Set it to \
a Graphics directive or to a list of Graphics directives.";

PointStyle::usage=
    "PointStyle is an option for TaylorPlot and TaylorPlot3D. Set it to a \
Graphics directive or to a list of Graphics directives.";

Printout::usage=
    "Printout is an option for TaylorPlot and TaylorPlot3D. Set it to False \
to supress the printing of the Taylor polynomial (useful for animations).";

Float::usage=
    "Float is an option for TaylorPlot3D. Set it to a small positive or \
negative number to force the wireframe Taylor plot to be shifted vertically \
by that amount. In some cases this will yield a better rendering of the two \
plots together.";

TaylorPlot::radius="`1` is not a positive number.";

TaylorPlot3D::radius=
    "`1` is neither a positive number nor a list of two positive numbers.";



Options[TaylorPlot]={
      Radius\[Rule]1,
      TaylorPlotStyle\[Rule]Hue[.6],
      PointStyle\[Rule]{Hue[1],PointSize[.015]},
      Printout\[Rule]True
      };

Options[TaylorPlot3D]={
      Radius\[Rule]0.5,
      PointStyle\[Rule]{Hue[1],PointSize[0.015]},
      TaylorPlotStyle\[Rule]Hue[.6],
      Printout\[Rule]True,Float\[Rule]0,
      PlotRange\[Rule]Automatic,
      ViewPoint\[Rule]{1.3,-2.4,2.}
      };



Begin["`Private`"]



makelist[object_]:=Switch[object,_List,object,_,List[object]];



TaylorPolynomial[f_,vars_,pt_,order_Integer?NonNegative]:=Module[{t,v,p},
      v=makelist[vars];
      p=makelist[pt];
      Normal[Series[f /. 
                        Thread[v \[Rule] t*v+p], {t, 0, order}]] /. 
          Thread[v\[Rule]v-p]/.t\[Rule]1
      ];

TaylorPolynomial[f_,vars_,order_Integer?NonNegative]:=
    Module[{n=Length[makelist[vars]]},
      TaylorPolynomial[f,vars,Table[0,{n}],order]
      ];

TaylorPolynomial[f_,vars_]:=TaylorPolynomial[f,vars,1];

TaylorPolynomialTerms[f_,vars_,pt_,order_Integer?NonNegative]:=
    Module[{t,v,p,poly,terms},
      v=makelist[vars];
      p=makelist[pt];
      poly=Normal[Series[f /. Thread[vars \[Rule] t*v+p], {t, 0, order}]] ;
      terms=Select[CoefficientList[poly,t],#=!=0&];
      terms/. Thread[v\[Rule]v-p]/.t\[Rule]1
      ];

TaylorPolynomialTerms[f_,vars_,order_Integer?NonNegative]:=
    Module[{n=Length[makelist[vars]]},
      TaylorPolynomialTerms[f,vars,Table[0,{n}],order]
      ];

TaylorPolynomialTerms[f_,vars_]:=TaylorPolynomialTerms[f,vars,1];

TaylorPlot[f_,{x_,xmin_,xmax_},x0_,n_Integer?NonNegative,opts___Rule]:=
    Module[{rad,ps,tps,po,xrad,s,tp,fp,
        pp},{rad,ps,tps,
          po}={Radius,PointStyle,TaylorPlotStyle,Printout}/.{opts}/.Options[
            TaylorPlot];
      rad=
        Switch[rad,_?Positive,rad,_,Return[Message[TaylorPlot::radius,rad]]];
      ps=makelist[ps];
      xrad=(xmax-xmin)*rad/2.;
      s=TaylorPolynomial[f,x,x0,n];
      If[po,
        Print["Taylor polynomial of degree ",n," expanded at ",x0," is T[",x,
          "] = ",s]];
      tp=Plot[s,{x,x0-xrad,x0+xrad},DisplayFunction\[Rule]Identity,
          PlotStyle\[Rule]tps,FilterOptions[Plot,opts]//Evaluate];
      fp=Plot[f,{x,xmin,xmax},DisplayFunction\[Rule]Identity,
          FilterOptions[Plot,opts]//Evaluate];
      pp=Graphics[{Sequence@@ps,Point[{x0,f/.x\[Rule]x0}]}];
      Show[fp,tp,pp,FilterOptions[Graphics,opts]//Evaluate,
        DisplayFunction\[Rule]$DisplayFunction]];

TaylorPlot[f_,{x_,xmin_,xmax_},n_Integer?NonNegative,opts___Rule]:=
    Module[{x0=(xmax+xmin)/2},TaylorPlot[f,{x,xmin,xmax},x0,n,opts]];

TaylorPlot[f_,{x_,xmin_,xmax_},opts___Rule]:=
    Module[{x0=(xmax+xmin)/2},TaylorPlot[f,{x,xmin,xmax},x0,1,opts]];

TaylorPlot3D[f_,{x_,xmin_,xmax_},{y_,ymin_,ymax_},{x0_,y0_},
      n_Integer?NonNegative,opts___Rule]:=
    Module[{ptsty,tps,rad,flo,pr,vp,po,xrad,yrad,s,i,j,tp,fp,
        pp},{ptsty,tps,rad,flo,pr,vp,
          po}={PointStyle,TaylorPlotStyle,Radius,Float,PlotRange,ViewPoint,
              Printout}/.{opts}/.Options[TaylorPlot3D];
      rad=
        Switch[rad,_List,rad,_?Positive,{rad,rad},_,
          Return[Message[TaylorPlot3D::radius,rad]]];
      ptsty=makelist[ptsty];
      xrad=(xmax-xmin)*rad[[1]]/2.;
      yrad=(ymax-ymin)*rad[[2]]/2.;
      s=TaylorPolynomial[f,{x,y},{x0,y0},n];
      If[po,
        Print["Taylor polynomial of degree ",n,
          " expanded about the point ",{x0,y0},", shown in wireform, is T[",x,
          ",",y,"] = ",s]];
      tp=SliceSurface[s+flo,{x,x0-xrad,x0+xrad},{y,y0-yrad,y0+yrad},
          DisplayFunction\[Rule]Identity,FilterOptions[SliceSurface,opts],
          XContours\[Rule]20,YContours\[Rule]20,ZContours\[Rule]0,
          XContourStyle\[Rule]tps,YContourStyle\[Rule]tps];
      fp=Plot3D[f,{x,xmin,xmax},{y,ymin,ymax},DisplayFunction\[Rule]Identity,
          FilterOptions[Plot3D,opts]//Evaluate,PlotPoints\[Rule]20,
          Mesh\[Rule]False];
      pp=Graphics3D[{Sequence@@ptsty,
            Point[{x0,y0,f+flo/.{x\[Rule]x0,y\[Rule]y0}}]}];
      Show[tp,fp,pp,ViewPoint\[Rule]vp,PlotRange\[Rule]pr,
        FilterOptions[Graphics3D,opts]//Evaluate,
        DisplayFunction\[Rule]$DisplayFunction]];

TaylorPlot3D[f_,{x_,xmin_,xmax_},{y_,ymin_,ymax_},n_Integer?NonNegative,
      opts___Rule]:=
    Module[{x0=(xmax+xmin)/2,y0=(ymax+ymin)/2},
      TaylorPlot3D[f,{x,xmin,xmax},{y,ymin,ymax},{x0,y0},n,opts]];

TaylorPlot3D[f_,{x_,xmin_,xmax_},{y_,ymin_,ymax_},opts___Rule]:=
    Module[{x0=(xmax+xmin)/2,y0=(ymax+ymin)/2},
      TaylorPlot3D[f,{x,xmin,xmax},{y,ymin,ymax},{x0,y0},1,opts]];



End[]	(* end the private context *)

Protect[TaylorPolynomial,TaylorPolynomialTerms,TaylorPlot,TaylorPlot3D,Radius,\
TaylorPlotStyle,Tail,PointStyle,Float,Printout]

EndPackage[] 	(* end the package context *)