(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)







(************************************
    
    By Bruce Torrence, 2003. 
    Updated 10/16/2004
  
  ************************************)


BeginPackage["RMCPackages`VectorSketch`",
  {"Graphics`Arrow`","Utilities`FilterOptions`"}]



Vector::usage = 
"Vector[{x,y}] returns a Graphics object representing the vector {x,y} rooted \
at the origin. Type Show[Vector[{x,y}]] to display the vector. The option \
Tail->{x0,y0} will place the tail of the vector at the given point (instead \
of at the origin); the option VectorStyle can be set to any Graphics \
directive (such as Hue[.6], to get a blue vector, for instance) or list of \
such directives. The option VectorLabel can be set to any string, and the \
option LabelOffset can be set to any offset value (such as {1,1} to place the \
label to the lower-left of center, for instance). The style of the vector \
label can be adjusted with the option LabelStyle.";

Vector3D::usage = 
"Vector3D[{x,y,z}] returns a Graphics3D object representing the vector \
{x,y,z} rooted at the origin. Type Show[Vector3D[{x,y,z}]] to display the \
vector. The option Tail->{x0,y0,z0} will place the tail of the vector at the \
given point (instead of at the origin); the option VectorStyle can be set to \
any Graphics3D directive (such as Hue[.6], to get a blue vector, for \
instance), or to a list of such directives. The option VectorLabel can be set \
to any string, and the option LabelOffset can be set to any offset value \
(such as {1,1} to place the label to the lower-left of center, for instance). \
The style of the vector label can be adjusted with the option LabelStyle. The \
head of the vector can be adjusted with the option HeadSize. For example, the \
setting HeadSize->{.5,.2,10} will yield and arrowhead length of .5, a radius \
of .2, and with 10 triangles forming the arrowhead. The sizes are absolute. \
The default is {Automatic,Automatic,7}, which will scale the arrowhead to \
match the vector. When showing several vectors in one output it is a good \
idea to set HeadSize to a common value for each vector. Vector3D will also \
accept any Graphics3D option.";

Tail::usage = 
"Tail is an option for Vector and Vector3D. The setting Tail->{2,3} in the \
Vector command will, for example, produce a vector with its tail at the point \
{2,3}. For Vector3D, the Tail setting must be a point in 3-space.";

VectorStyle::usage = 
"VectorStyle is an option for Vector and Vector3D. The setting \
VectorStyle->RGBColor[0,0,1] will, for example, produce a blue vector. It can \
be set to a single Graphics (Vector) or Graphics3D (Vector3D) directive, or \
to a list of such directives. When setting it to a list in Vector3D, a color \
directive such as Hue or RGBColor must be the first directive in the list.";

VectorLabel::usage = 
"VectorLabel is an option for Vector and Vector3D. Set it to a text string \
(enclosed in double quotation marks) to produce a vector labeled with that \
string.";

LabelOffset::usage = 
"LabelOffset is an option for Vector and Vector3D. The setting \
LabelOffset->{1,1} will, for example, produce a label diplayed to the lower \
left of the midpoint of the vector.";

LabelStyle::usage = 
"LabelStyle is an option for Vector and Vector3D. It may be set to any option \
value accepted by the TextStyle option of the Text command.";

HeadSize::usage = 
"HeadSize is an option for Vector3D. It is set to a list of length 3. The \
first item is the arrowhead length (in absolute size, so a setting of 1 will \
yield a head that is 1 unit in length); the second item is the head radius; \
and the last item is the number of polygons used to render the head. Either \
of the first two items may be set to Automatic (the default setting), which \
results in values proportional to the length of the vector.";

ShowVectorDecomposition::usage = 
"ShowVectorDecomposition[{x,y,z}] will display the vector {x,y,z} together \
with the component vectors x*i, y*j, and z*k. It will accept any options \
accepted by Graphics3D or by Vector3D.";



Options[Vector]:={Tail\[Rule]{0,0},VectorStyle\[Rule]Hue[1],
      VectorLabel\[Rule]None,LabelOffset\[Rule]{-1,1},
      LabelStyle\[Rule]{FontWeight\[Rule]"Bold",FontFamily\[Rule]"Times"}};

Options[Vector3D]:={Tail\[Rule]{0,0,0},HeadSize\[Rule]{Automatic,Automatic,7},
      VectorStyle\[Rule]Hue[1],VectorLabel\[Rule]None,
      LabelOffset\[Rule]{-1,1},
      LabelStyle\[Rule]{FontWeight\[Rule]"Bold",FontFamily\[Rule]"Times"}};



Begin["`Private`"]



makelist[object_]:=Switch[object,_List,object,_,List[object]];



Vector[coords_List,opts___Rule]:=Module[{tail,vecsty,veclabel,laboffset,pic},
		
    {tail,vecsty,veclabel,laboffset,
        labsty}={Tail,VectorStyle,VectorLabel,LabelOffset,
            LabelStyle}/.{opts}/.Options[Vector];
    
    vecsty=makelist[vecsty];
    labsty=makelist[labsty];
            
    If[coords==={0,0},
      pic=Graphics[Join[{PointSize[.02]},vecsty,{Point[{0,0}]}]],
      
      (* ELSE - the rest is for displaying nonzero vectors *)
      
      If[veclabel===None,
          
          pic=Graphics[Append[vecsty,Arrow[tail,coords+tail]],
              FilterOptions[Graphics,opts]//Evaluate],
          pic=Graphics[{Append[vecsty,Arrow[tail,coords+tail]],
                
                Text[veclabel,tail+.5*coords,laboffset,
                  TextStyle\[Rule]labsty]},
              FilterOptions[Graphics,opts]//Evaluate]
          ];
      ];(*end ELSE*)
    pic
    ]

\!\(\*
  RowBox[{\(Vector3D[coords_List, opts___Rule]\), ":=", 
    RowBox[{"Module", "[", 
      RowBox[{\({tail, hs, vecsty, veclabel, laboffset, len, headbaseinit, 
          mat, theta, headbasepts, polys, pic}\), ",", "\n", "\t\t", 
        "\[IndentingNewLine]", 
        RowBox[{\({tail, hs, vecsty, veclabel, laboffset, 
              labsty} = \({Tail, HeadSize, VectorStyle, VectorLabel, 
                  LabelOffset, LabelStyle} /. {opts}\) /. Options[Vector3D]\),
           ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", \(vecsty = makelist[vecsty]\), ";", 
          "\[IndentingNewLine]", \(labsty = makelist[labsty]\), ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
            
            RowBox[{\(coords === {0, 0, 0}\), ",", 
              "\[IndentingNewLine]", \(pic = 
                Graphics3D[
                  Join[{PointSize[ .02]}, vecsty, {Point[{0, 0, 0}]}], 
                  FilterOptions[Graphics, opts] // Evaluate]\), ",", 
              "\[IndentingNewLine]", 
              "\[IndentingNewLine]", \( (*\ 
                ELSE\  - \ 
                  the\ rest\ is\ for\ displaying\ nonzero\ vectors\ *) \), 
              "\[IndentingNewLine]", 
              
              RowBox[{\(len = Norm[coords]\), ";", 
                "\[IndentingNewLine]", \(If[hs[\([1]\)] === Automatic, 
                  hs[\([1]\)] =  .05*len]\), 
                ";", \( (*\ set\ head\ length\ *) \), 
                "\[IndentingNewLine]", \(If[hs[\([2]\)] === Automatic, 
                  hs[\([2]\)] =  .015*len]\), 
                ";", \( (*\ set\ head\ width\ *) \), "\n", 
                "      ", \({wx, wy, wz} = coords/len\), ";", 
                "\[IndentingNewLine]", \(headbaseinit = 
                  If[wx =!= 0 || wy =!= 0, {\(-wy\), wx, 0}, {0, \(-wz\), 
                      wy}]\), 
                ";", \( (*vector\ orthog\ to\ coords; \ 
                  used\ for\ first\ point\ of\ arrowhead\ base*) \), 
                "\[IndentingNewLine]", \(headbaseinit = 
                  hs[\([2]\)]*headbaseinit/Norm[headbaseinit]\), ";", 
                "\[IndentingNewLine]", 
                RowBox[{"mat", "=", 
                  RowBox[{"(", GridBox[{
                        {"0", \(-wz\), "wy"},
                        {"wz", "0", \(-wx\)},
                        {\(-wy\), "wx", "0"}
                        }], ")"}]}], ";", 
                "\[IndentingNewLine]", \( (*\ 
                  mat\ is\ used\ to\ rotate\ headbaseinit\ around\ coord\ to\ \
form\ arrowhead\ base; \ 
                  based\ on\ Rodrigues\ Rotation\ formula\  - \ 
                    see\ MathWorld\ *) \), 
                "\[IndentingNewLine]", \(theta = 2  \[Pi]/\((hs[\([3]\)])\)\),
                 ";", "\[IndentingNewLine]", \(mat = MatrixExp[theta*\ mat]\),
                 ";", "\[IndentingNewLine]", \(headbasepts = 
                  NestList[mat . # &, headbaseinit, hs[\([3]\)] - 1]\), ";", 
                "\[IndentingNewLine]", \( (*these\ are\ the\ pts\ around\ the\
\ arrowhead\ base\  - \ now\ translate\ them*) \), 
                "\[IndentingNewLine]", \(headbasepts = 
                  Map[Plus[tail, coords, \(-hs[\([1]\)]\)*{wx, wy, wz}, #] &, 
                    headbasepts]\), ";", 
                "\[IndentingNewLine]", \(polys = 
                  Map[Polygon[Append[#, tail + coords]] &, 
                    Partition[headbasepts, 2, 1, 2]]\), ";", 
                "\[IndentingNewLine]", \(If[
                  veclabel === None, \[IndentingNewLine]pic = 
                    Graphics3D[{Append[vecsty, 
                          Line[{tail, coords + tail}]], {SurfaceColor[
                            vecsty[\([1]\)]], polys}}, PlotRange \[Rule] All, 
                      FilterOptions[Graphics, opts] // 
                        Evaluate], \[IndentingNewLine]pic = 
                    Graphics3D[{Append[vecsty, 
                          Line[{tail, coords + tail}]], {SurfaceColor[
                            vecsty[\([1]\)]], polys}, \[IndentingNewLine]Text[
                          veclabel, tail +  .5*coords, laboffset, 
                          TextStyle \[Rule] labsty]}, 
                      FilterOptions[Graphics, opts] // Evaluate, 
                      PlotRange \[Rule] All]\[IndentingNewLine]]\), ";"}]}], 
            "\[IndentingNewLine]", "]"}], ";", \( (*end\ ELSE*) \), 
          "\[IndentingNewLine]", "pic"}]}], "\n", "\t", "]"}]}]\)

ShowVectorDecomposition[{v1_,v2_},opts___Rule]:=Module[{},
    Show[
        Vector[v1{1,0},VectorStyle\[Rule]{Hue[.3],Dashing[{.02}]},
          VectorLabel\[Rule]v1"i"],
        Vector[v2{0,1},VectorLabel\[Rule]v2"j",
          VectorStyle\[Rule]{Hue[0],Dashing[{.02}]},Tail\[Rule]{v1,0}],
        Vector[{v1,v2},VectorStyle\[Rule]Hue[.7],
          VectorLabel\[Rule]v1"i"+v2"j",LabelOffset\[Rule]{0,4}],
        FilterOptions[Graphics,opts]//Evaluate,PlotRange\[Rule]All,
        ImageSize\[Rule]400
        ];
    ]

ShowVectorDecomposition[{v1_,v2_,v3_},opts___Rule]:=
  Module[{len=Norm[{v1,v2,v3}],hs},
    hsOld=HeadSize/.Options[Vector3D];
    hs=HeadSize/.{opts}/.Options[Vector3D];
    If[hs[[1]]===Automatic,hl=.05*len,hl=hs[[1]]];
    If[hs[[2]]===Automatic,hw=.015*len,hw=hs[[2]]];
    SetOptions[Vector3D,HeadSize\[Rule]{hl,hw,hs[[3]]}];
    Show[
      Vector3D[v1{1,0,0},VectorStyle\[Rule]{Hue[.3],Dashing[{.02}]},
        VectorLabel\[Rule]v1"i"],
      Vector3D[v2{0,1,0},VectorLabel\[Rule]v2"j",
        VectorStyle\[Rule]{Hue[.1],Dashing[{.02}]},Tail\[Rule]{v1,0,0}],
      Vector3D[v3{0,0,1},VectorLabel\[Rule]v3"k",
        VectorStyle\[Rule]{Hue[1],Dashing[{.02}]},Tail\[Rule]{v1,v2,0}],
      Vector3D[{v1,v2,v3},VectorStyle\[Rule]Hue[.7],
        VectorLabel\[Rule]v1"i"+v2"j"+v3"k",LabelOffset\[Rule]{0,5}],
      FilterOptions[Graphics,opts]//Evaluate,PlotRange\[Rule]All,
      ImageSize\[Rule]400
      ];
    SetOptions[Vector3D,HeadSize\[Rule]hsOld];
    ]



End[]	(* end the private context *)

Protect[Vector,Vector3D,ShowVectorDecomposition,Tail,VectorStyle,VectorLabel,\
LabelStyle,LabelOffet,HeadSize]

EndPackage[] 	(* end the package context *)