(* Title: Kernel Initialization Declarations File for
	         RMCPackages *)

(* :Summary: This file contains declarations of all the 
major symbols contained in files in this directory.  
When loaded, it sets up the symbols with attribute 
Stub, so the correct package will be loaded when the 
symbol is called.  *)

(* :Author: Bruce F. Torrence *)

(* :History: File created on 15 January, 1997. 
Last modified on 10-16-2004 *)

BeginPackage["RMCPackages`Kernel`init`"]
EndPackage[]

(* Declarations for file RMCPackages`BasicRegression` *)

DeclarePackage["RMCPackages`BasicRegression`", 
  {"ScatterPlot", "LinearFit", "ExponentialFit",
   "PowerFit", "SquaredResidualPlot", "ResidualTable", 
   "LinearResidualPlot", "ExponentialResidualPlot",
   "PowerResidualPlot"}]
   
(* Declarations for file RMCPackages`CircularPlot3D` *)   
   
DeclarePackage["RMCPackages`CircularPlot3D`", 
  {"CircularPlot3D"}]    

(* Declarations for file RMCPackages`ComplexMap` *)   
   
DeclarePackage["RMCPackages`ComplexMap`", 
  {"CartesianMap, CartesianMapMovie"}]    

(* Declarations for file RMCPackages`Curvature` *)   
   
DeclarePackage["RMCPackages`Curvature`", 
  {"\[Kappa]", "UnitTangent", "UnitNormal",
  "EvoluteMovie", "OsculatingCircleMovie"}]    

(* Declarations for file RMCPackages`Eigenspace` *)   
   
DeclarePackage["RMCPackages`Eigenspace`", 
  {"ShowSpan", "Eigenspace", "Eigentable"}] 
     
(* Declarations for file RMCPackages`InversePlot` *)   
   
DeclarePackage["RMCPackages`InversePlot`", 
  {"InversePlot"}] 

(* Declarations for file RMCPackages`ListScheduling` *)   
   
DeclarePackage["RMCPackages`ListScheduling`", 
  {"AllScheduleTimes", "LPA", "RenderSchedule", 
  "ScheduleTime", "ShowSchedule", "ShowSchedulingDigraph"}] 

(* Declarations for file RMCPackages`ODETools` *)   
   
DeclarePackage["RMCPackages`ODETools`", 
  {"DirectionField"}] 

(* Declarations for file RMCPackages`ParametricPlottingTools` *)   
   
DeclarePackage["RMCPackages`ParametricPlottingTools`", 
  {"DirectedParametricPlot", "ParametricPlotMovie", 
  "HomotopyMovie"}]    

(* Declarations for file RMCPackages`PolarRectangles` *)   
   
DeclarePackage["RMCPackages`PolarRectangles`", 
  {"PolarRectangle", "PolarRectangle3D", "PolarGrid",
  "PolarGrid3D", "VerticalPolygon", "VerticalWall", 
  "PolarRectangularSolid","PolarSolid", "PolarRiemannSum"}] 

(* Declarations for file RMCPackages`PolyRegression` *)   
   
DeclarePackage["RMCPackages`PolyRegression`", 
  {"QuadraticFit", "CubicFit","QuarticFit",
   "PolynomialFit"}] 
  
(* Declarations for file RMCPackages`Popcorn` *)   
   
DeclarePackage["RMCPackages`Popcorn`", 
  {"Popcorn"}]    

(* Declarations for file RMCPackages`RiemannSum` *)   
   
DeclarePackage["RMCPackages`RiemannSum`", 
  {"RiemannSum"}]    

(* Declarations for file RMCPackages`SequenceTools` *)   
   
DeclarePackage["RMCPackages`SequenceTools`", 
  {"BifurcationPlot", "Cobweb", "CobwebMovie", "Diff", 
  "\[CapitalDelta]", "DeltaTable",
  "LogisticFit", "SequencePlot", "SequenceTable"}]    

(* Declarations for file RMCPackages`ShowRegion` *)   
   
DeclarePackage["RMCPackages`ShowRegion`", 
  {"ShowRegion"}]    

(* Declarations for file RMCPackages`ShowColors` *)   
   
DeclarePackage["RMCPackages`ShowColors`", 
  {"ShowColors"}]
      
(* Declarations for file RMCPackages`ShowTable` *)   
   
DeclarePackage["RMCPackages`ShowTable`", 
  {"ShowTable"}]    

(* Declarations for file RMCPackages`SliceSurface` *)   
   
DeclarePackage["RMCPackages`SliceSurface`", 
  {"SliceSurface"}]    
   
(* Declarations for file RMCPackages`Spirograph` *)

DeclarePackage["RMCPackages`Spirograph`", 
  {"Spirograph", "SpirographCircles", "SpirographMovie",
  "SpirographMovieGraphics"}]

(* Declarations for file RMCPackages`TaylorTools` *)   
   
DeclarePackage["RMCPackages`TaylorTools`", 
  {"TaylorPolynomial", "TaylorPolynomialTerms", 
  "TaylorPlot", "TaylorPlot3D"}]    

(* Declarations for file RMCPackages`VectorSketch` *)   
   
DeclarePackage["RMCPackages`VectorSketch`", 
  {"Vector", "Vector3D", "ShowVectorDecomposition",
  "Tail", "VectorStyle", "VectorLabel", "LabelStyle",
  "LabelOffset"}]    
   
   
Null